CCodeDir := "./";

VandermondeMatrixA := define_external('VandermondeMatrix1',
AA::ARRAY(1..nn,1..nn,integer[8],order=C_order),
  nn::integer[4],
  XX::ARRAY(1..nn,integer[8],order=C_order),
  pp::integer[8],
  LIB=cat(CCodeDir,"detinterp4.so"),
  RETURN::integer[8]):
VandermondeMatrixA := subsop(1=(AA,nn,XX,pp),eval(VandermondeMatrixA)):

VandermondeMatrixB := define_external('VandermondeMatrix2',
AA::ARRAY(1..nn,1..nn,integer[8],order=C_order),
  nn::integer[4],
  XX::ARRAY(1..nn,integer[8],order=C_order),
  pp::integer[8],
  LIB=cat(CCodeDir,"detinterp4.so"),
  RETURN::integer[8]):
VandermondeMatrixB := subsop(1=(AA,nn,XX,pp),eval(VandermondeMatrixB)):

bbVandermondeCheatCA := define_external('bbVandermondeMatrixCheat1',
  XX::integer[8],
  nn::integer[4],
  pp::integer[8],
  LIB=cat(CCodeDir,"detinterp4.so"),
  RETURN::integer[8]):
bbVandermondeCheatCA := subsop(1=(XX,nn,pp),eval(bbVandermondeCheatCA)):

bbVandermondeCheatCB := define_external('bbVandermondeMatrixCheat2',
  XX::integer[8],
  nn::integer[4],
  pp::integer[8],
  LIB=cat(CCodeDir,"detinterp4.so"),
  RETURN::integer[8]):
bbVandermondeCheatCB := subsop(1=(XX,nn,pp),eval(bbVandermondeCheatCB)):

EVAL264 := define_external('eval64s',
    FF::integer[8],
    XX::integer[8],
    AA::integer[8],
    pp::integer[8], LIB=cat(CCodeDir,"evalGP1.so"),
    RETURN::integer[8]):

pointer := proc(f) option inline; addressof(f)-4*(2^63-1); end:

Eval264 := proc(f,X,alpha,p)
    if type(f,integer) then modp(f,p); else EVAL264(pointer(f),pointer(X),pointer(alpha),p); fi;
end:

test2 := define_external('test',
AA::integer[8],
nn::integer[4],
 LIB=cat(CCodeDir,"detinterp4.so")
):
test2 := subsop(1=(AA,nn),eval(test2)):

with(LinearAlgebra):

local probeCount;

pointer := proc(f) option inline; addressof(f)-4*(2^63-1); end:

bbVanCFast1 := proc(n)

 local b;

 b := proc(alpha,p)

     local A;

     probeCount := probeCount + 1;

     #A := Array(1..2*n,alpha,datatype=integer[8]);

     #print(A); print(bbVandermondeCheatCA(A,n,p));
     #print(alpha);

     return bbVandermondeCheatCA(pointer(alpha),n,p);

  end proc;

end proc;

bbVanCFast2 := proc(n)

  local b;

 b := proc(alpha,p)

     local A;

     probeCount := probeCount + 1;

     #Arr := Array(1..2*n,alpha,datatype=integer[8]);

     #print(Arr); print(bbVandermondeCheatCB(Arr,n,p));


     return bbVandermondeCheatCB(pointer(alpha),n,p);

  end proc;

end proc;


#create a black box for a Vandermonde matrix (cheat)
bbVanC := proc(n,c)

   local b;

   b := proc(alpha,p)

      local i,j,opt,nn,m,Arr,M,d,pow,pows;
      #print("here");
      probeCount := probeCount+1;
      #print("here");
      opt := c;
      nn := n; m := n/2;

      Arr := Array(1..nn,datatype=integer[8],order=C_order);
      M := Array(1..nn, 1..nn,datatype=integer[8],order=C_order);

      for i from 1 to m do
         Arr[i] := alpha[i];
      od;

     # print(Arr); print(M);

      #move relevant points to first n entries
      if opt = 2 then
         for i from 1 to m do
            Arr[i+m] := alpha[nn+m+i];
         od;
      else
         for i from 1 to m do
            Arr[i+m] := alpha[m+i];
         od;
      fi;

      #print(Arr); print(M);

      #print("a");
      #print(M);

      VandermondeMatrix2(M,nn,Arr,p);

      #print("b");
      #print(M);

      #print(M);

      d := Det64s(M,nn,p);

      #print("c");
      #print(d);

      return d;

   end proc;

   return b;

end proc;

#create a black box for a Vandermonde matrix (cheat)
bbGarrettTest1 := proc(nn,mm,c)

   local b;

   b := proc(alpha,p)

      local i,j,opt,n,m,base,curMul,sol,ex,pow,pows;

      opt := c;
      n := nn;
      m := mm;
      sol := 1;

      probeCount := probeCount + 1;

      if opt = 1 then ex := 2; else ex := 3; fi;

      for i from 1 to n do
         base := alpha[i]; pow := m;

         #get the powers for binomial multiplication

         if pow=1 then
            sol := sol*(base+1) mod p;
         else
            pows := [seq(0,j=1..floor(log[2](pow))+1)];
            pows[1] := base+1;
            for j from 2 to nops(pows) do
               pows[j] := pows[j-1]^2 mod p;
            od;

            for j from nops(pows) to 1 by -1 do
               if pow >= 2^(j-1) then
                  pow := pow - 2^(j-1);
                  sol := sol*pows[j] mod p;
               fi;
           od;
         fi;
      od;

      for i from 1 to n do
         base := alpha[i]; pow := (n+1-i)*m;

         #get the powers for binomial multiplication
         if pow = 1 then
            sol := sol*(base+ex) mod p;
         else
            pows := [seq(0,j=1..floor(log[2](pow))+1)];
            pows[1] := base+ex;
            for j from 2 to nops(pows) do
               pows[j] := pows[j-1]^2 mod p;
            od;

            for j from nops(pows) to 1 by -1 do
               if pow >= 2^(j-1) then
                  pow := pow - 2^(j-1);
                  sol := sol*pows[j] mod p;
              fi;
            od;
         fi;
      od;


      return sol;

   end proc;

end proc;

#create a black box for a given matrix and variable set
bbdmgen := proc(M::Matrix,X)

   local AA,n,b;

   b := proc(alpha,pp)

      local MM,nn,XX,BB,i,st,db;

      MM := M; #print(MM);
      XX := X; #print(XX); print(alpha);
      BB := Eval(MM,{seq(XX[i]=alpha[i],i=1..nops(XX))}) mod pp; #print(BB);
      db := Determinant(BB) mod pp;
      probeCount := probeCount + 1;
      return db;

   end proc;

   return b;

end proc:
#create a black box for a given polynomial and variable set
bbpolygen := proc(A,G,X)

   local b,a,g;

   a := expand(A);
   g := expand(G);

   #print(g);

   b := proc(alpha,p)

      local a2,g2,i;

      #probeCount := probeCount + 1;

      #Eval64(A,X,[1,2,3,4,5],p);
      #print(alpha);

      a2 := Eval264(a mod p,X,alpha,p); #print(a);
      g2 := Eval264(g mod p,X,alpha,p); #print(g);
      #a := Eval(A,[seq(X[i]=alpha[i],i=1..nops(X))]) mod p;
      #g := Eval(G,[seq(X[i]=alpha[i],i=1..nops(X))]) mod p;

      return a2*g2 mod p;

   end proc;

   return eval(b);

end proc;
